32bit arithmatic
----------------
Programs like FileDoor <tm>, MTS <tm>, RFW/RFC <tm> and MTA <tm> (and  a
lot of programs from other people) which were written in Borland  Pascal
7.0 (and, as far as  I can see, those written  in TP 6.0 with a  special
extender  unit  for  fast  calculations,  like  older FileDoor version),
suddenly  worked  buggy  on  some  configurations.  Thanks to the Pascal
forum and  especially D.J.  Murdoch, one  of the  creators of the famous
TP/BP bug-lists), I could finally trap the problem.

BP7.0 (and extender units under TP6, as far as I can see) introduce  the
so called 32-bit  arithmetic when the  compiled program runs  on a 80386
or 80486. This will greatly enhance the speed on long integer  (LONGINT)
calculations. Now there  is a 'slight'  problem with these  calculations
under BP7.0 when executed  in combination with certain  operating system
software, like Novell's dedicated file-server version 2.2.

This software has the habit  of trashing the extended registers  (Novell
2.2 seems to trashes EAX (extended) register at every timer-tick).  This
makes long integer calculations (32-bit on a 80386/80486) under  Borland
Pascal 7.0 unreliable in these environments. Later Novell versions  seem
to have solved the problem.

There are routines available which can  help to detect if you have  such
a problem (see the BP7BUGS2.xxx file with the Borland Pascal 7.0  bugs).
Also there is  an option to  ignore 32-bit arithmetic  in BP7.0 programs
and to  switch back  to 16-bit  arithmetic. This  option is available in
all the new  DISP products and  will help some  users, at the  cost of a
little bit  of speed,  to run  these programs  EVEN if their environment
contains the bug described above.

In all new DISP-programs, a /8086 (or -8086 which does the same)  option
can be coded on the command-line. This option is interpreted AS SOON  AS
POSSIBLE when the program comes  active. If the option is  detected, the
program will switch  to 16-bit arithmetic  and the calculations  will be
correct again.

So far the ONLY problems  that were  reported, are  in FileDoor 3.10 and
earlier versions. It  is known as  the 'Timeout/Inactivity bug'.  When a
user  entered  FileDoor  she/he  got  an  error  'User timeout' or 'User
terminated due to inactivity' and execution of FileDoor was  impossible.
Also in RFC/F,  MTS and MTA  there are 'strange'  reports in combination
with Novell 2.2 (and some other  software). I imagine that the usage  of
the  /8086  command-line  option  will  solve  at  least  SOME  of these
problems but there  can well be  other bugs in  my programs as  well. In
any case, please report these problems !

The usage of the /8086 command-line  option has NO meaning when you  run
a plain-vanilla DOS  environment (with a  known memory manager  and/or a
multitasking program)  or when  you have  a 8086/80186/80286.  Only when
you experience STRANGE problems AND you have a 80386/80486, you can  try
to use the /8086 switch.

Currently,  the  /8086  (or  -8086)  command-line  options are (will be)
available in the following releases of DISP programs:

- RFW       1.30
- MTS       7.81
- FileDoor  4.03
- MTA      15.56 (or higher, not ready yet)

Based  on  the  result,  all  other  programs will be enhanced with this
option, if there is  a need to. The  coding will be removed  if there is
no  need  for  it  anymore.  The  overhead  involved with this coding is
minimal (around 50 bytes of coding).


                                           Thanks. Robert W. van Hoeven
